=== debian/changelog ===
ros-indigo-fiducial-lib (0.0.2-0trusty) trusty; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Wayne Gramlich <wayne@gramlich.net>  Wed, 23 Nov 2016 02:38:44 -0000
